import java.util.*;

public class ComparatorTester
{
   public static void main(String[] args)
   {
      List<Country> countries = Arrays.asList(
         new Country("Uruguay",   176220,   3.4),
         new Country("Thailand",  514000,  67.0),
         new Country("Belgium",    30528,  11.0),
         new Country("Zaire",    2345410,  46.5),
         new Country("Belize",     22966,   0.334));

      Comparator<Country> comp1 = new CountryComparatorByName_a();
      Comparator<Country> comp2 = new CountryComparatorByName_d();
      Comparator<Country> comp3 = new CountryComparatorByArea_a();
      Comparator<Country> comp4 = new CountryComparatorByArea_d();
      Comparator<Country> comp5 = new CountryComparatorByPopulation_a();
      Comparator<Country> comp6 = new CountryComparatorByPopulation_d();

      Collections.sort(countries, comp1);
      // Now the List is sorted by country name, ascending.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();

      Collections.sort(countries, comp2);
      // Now the List is sorted by country name, descending.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();

      Collections.sort(countries, comp3);
      // Now the List is sorted by area, ascending.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();

      Collections.sort(countries, comp4);
      // Now the List is sorted by area, descending.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();

      Collections.sort(countries, comp5);
      // Now the List is sorted by population, ascending.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();

      Collections.sort(countries, comp6);
      // Now the List is sorted by population, descending.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();
   }
}